##################################################################
# autor:      yW1674											 #
# version: 	  2.0										         #
##################################################################

BUILD_Print()
{
    echo "$(date +%F' '%T[grub_update.sh])$@" >> /var/log/update.log
}

BUILD_LIB_CheckResult()
{
    if [ "$?" -ne 0 ]
    then
        BUILD_Print exec $@ failed, you must check it.
        echo "update grub failed, please check /var/log/update.log"
    	exit 1
    else
    	BUILD_Print exec $@ successfully.
    fi
}


#~{;qH!~} SSD ~{TZ~}/dev/~{OB6TS&5DIh18=Z5cC{3F~}
BUILD_GetSsdNode()
{
   #~{EP6O~} /proc/disk/global ~{ND<~JG7q4fTZ~}
   if ! [ -e /proc/disk/global ]
   then
       BUILD_Print /proc/disk/global is not exist
       echo "update grub failed, please check /var/log/update.log"
   	   exit 1
   fi

   SSD_NAME=$(cat /proc/disk/global | awk '/SSD disk name/{print $4}')
   #~{6T~}SSD_NAME ~{7G?UEP6O~}
   if [ "$SSD_NAME" == "" ] || [ "$SSD_NAME" == "NULL" ]
   then
       BUILD_Print SSD DEVNode is NULL, please check
       echo "update grub failed, please check /var/log/update.log"
       exit 1
   fi

   BUILD_Print SSD DevNode is $SSD_NAME.
}

#~{9RTX~}uboot ~{6TS&5D~}ssd~{7VGx5=~}/boot ~{D?B<OB~}
BUILD_MountBootDir()
{
    #~{EP6O~}/boot ~{D?B<JG7q4fTZ#,2;4fTZTr44=(~}
    if ! [ -d /boot ]
    then
        mkdir -p /boot
    fi

	#~{2;9\~}grub~{7VGxJG7q9RTX#,OH~}umount grub~{7VGx!#~}
	umount /dev/${SSD_NAME}1  1>>/var/log/update.log 2>&1

    #~{9RTX~}uboot~{7VGx5=~}/boot~{D?B<OB~}
    mount /dev/${SSD_NAME}1 /boot 1>>/var/log/update.log 2>&1
    BUILD_LIB_CheckResult mount uboot partition to /boot dir
}

#~{P6TX~}/boot~{D?B<~}
BUILD_UmountBootDir()
{
	umount /dev/${SSD_NAME}1  1>>/var/log/update.log 2>&1
}

#~{;V84>I5D>5Oq~}
BUILD_RecoveryOldImage()
{
	rm -rf /boot/*
	BUILD_LIB_CheckResult recoveryOldImage
	cp -rf /saved_old_grub/* /boot/
	cp -rf /saved_old_grub/* /boot/
	#BUILD_LIB_CheckResult recoveryOldImage
	rm -rf /saved_old_grub
}

#grub~{02W0<l2i~},~{Hg9{3vOVNJLb~},~{Tr;V84>I>5Oq!#~}
BUILD_InstallCheck()
{
    if [ "$?" -ne 0 ]
    then
        BUILD_Print exec $@ failed, you must check it.
        BUILD_Print now to recovery the old image
		BUILD_RecoveryOldImage
		echo "update grub failed, please check /var/log/update.log"
    	exit 1
    else
    	BUILD_Print exec $@ successfully.
    fi
}

BUILD_GrubInstall()
{
    #~{;qH!~}cpu ~{@`PM~}
    CPU_TYPE=$(uname -m)

    #~{1#4f7VGxVPV.G05D~}grub~{>5Oq~}
    mkdir -p /saved_old_grub
    BUILD_LIB_CheckResult create saved_old_grub dir

    cp -rf /boot/* /saved_old_grub/
    #BUILD_LIB_CheckResult copy old grub image to saved_old_grub dir

    #~{Ge?U~}grub~{7VGxOB5DKySP6+Nw~}
    rm -rf /boot/*
    BUILD_LIB_CheckResult clear everything in /boot dir


    #~{=bQ9~}grub~{02W00|5=~} ~{8yD?B<OB~}
    tar xjf grub_install.tar.bz2 -C / 1>>/var/log/update.log 2>&1
    BUILD_InstallCheck umcompress the grub_install.tar.bz2

	#
    if [ "$CPU_TYPE" == "x86_64" ]
    then
        /grub_install/sbin/x86_64-grub-install --target=x86_64-efi --efi-directory=/boot --bootloader-id=UNIVIEW_EFI --boot-directory=/boot/EFI --recheck
		BUILD_InstallCheck ${CPU_TYPE}-grub-install

		cp -rf /grub_install/config/*  /boot/EFI/grub/
		BUILD_InstallCheck copy grub config file
    else
    	BUILD_Print unsupport ${CPU_TYPE} this cpu.
    	BUILD_RecoveryOldImage
    	echo "update grub failed, please check /var/log/update.log"
    	exit 1
	fi

	#~{I>3}187]5DD?B<~}
	rm -rf /saved_old_grub
	BUILD_LIB_CheckResult rm saved_old_grub
}

BUILD_Main()
{
    BUILD_GetSsdNode
    BUILD_MountBootDir
    BUILD_GrubInstall
    BUILD_UmountBootDir

    BUILD_Print update grub successfully.
	exit 0
}

BUILD_Main
